/*****************************************************************

Copyright 2008 Aaron Seigo <aseigo@kde.org>
Copyright 2010 Lukas Appelhans <l.appelhans@gmx.de>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************/


#ifndef APPSTATS_EXPORT_H
#define APPSTATS_EXPORT_H

/* needed for APPSTATS_EXPORT and KDE_IMPORT macros */
#include <kdemacros.h>

#ifndef APPSTATS_EXPORT
# if defined(MAKE_APPSTATS_LIB)
   /* We are building this library */ 
#  define APPSTATS_EXPORT KDE_EXPORT
# else
   /* We are using this library */ 
#  define APPSTATS_EXPORT KDE_IMPORT
# endif
#endif

# ifndef APPSTATS_EXPORT_DEPRECATED
#  define APPSTATS_EXPORT_DEPRECATED KDE_DEPRECATED APPSTATS_EXPORT
# endif

#endif
