#include "imagebrowser.h"
#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <KDE/KLocale>

static const char description[] =
    I18N_NOOP("A KDE 4 Application");

static const char version[] = "0.1";

int main(int argc, char **argv)
{
    KAboutData about("imagebrowser", 0, ki18n("ImageBrowser"), version, ki18n(description),
                     KAboutData::License_GPL, ki18n("(C) 2007 Sebastian Trueg"), KLocalizedString(), 0, "trueg@kde.org");
    about.addAuthor( ki18n("Sebastian Trueg"), KLocalizedString(), "trueg@kde.org" );

    KCmdLineArgs::init(argc, argv, &about);
    KCmdLineOptions options;
    KCmdLineArgs::addCmdLineOptions(options);
    KApplication app;

    ImageBrowser *widget = new ImageBrowser;
    widget->show();
    return app.exec();
}
