/***************************************************************************
 *   Copyright (C) 2009 by Björn Ruberg <bjoern@ruberg-wegener.de>         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#include "icon.h"
#include <QGraphicsScene>
#include <ScreenControl.h>

ControlIcon::ControlIcon(QObject *parent, const QVariantList &args)  :
	Plasma::PopupApplet(parent, args) {
	//setAspectRatioMode(Plasma::IgnoreAspectRatio);

	setPopupIcon("preferences-desktop-display-randr");
	//setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
        
	//connect(this, SIGNAL(sizeHintChanged()), this, SLOT(sizeChanged()));
	m_mainwidget = new ScreenControl( this );
}


ControlIcon::~ControlIcon() {
}

void ControlIcon::init() {
    /*if(!extender()->hasItem("contactlist")) {
	Plasma::ExtenderItem *eItem = new Plasma::ExtenderItem(extender());
	eItem->setName("contactlist");
	initExtenderItem(eItem);
    }*/

}


QGraphicsWidget* ControlIcon::graphicsWidget(){
    return m_mainwidget;
}

// This is the command that links your applet to the .desktop file
K_EXPORT_PLASMA_APPLET(screen_management, ControlIcon)
