/*
# * Copyright(c) 2008 Matthew Adams <roguestar191 at comcast.net>
# *
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License as
# * published by the Free Software Foundation; either version 2 of
# * the License, or(at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http//www.gnu.org/licenses/>.
# */

namespace welcome_plasmoid {
	class Ui_WelcomePlasmoid : public Ui_LinksTab, Ui_WebBrowser, Ui_WelcomeTab<Plasma::PopupApplet>, QGraphicsWidget {
		public:
			QGraphicsGridLayout gridLayout;
			QGraphicsGridLayout topLayout;
			ResizeFrame topFrame;
			GloweyLabel welcomeUsernameLabel;
			void retranslate_ui(Plasma::PopupApplet&);
			void retranslateUi(Plasma::PopupApplet&);
			QString translate(QString& strin);
			Plasma::IconWidget *addTool(QString&iconstring, QGraphicsLinearLayout &layout);
			Plasma::IconWidget *addToolNoLayout(QString& iconstring);
			
			std::vector<Plasma::Label> mychildren; // badly named... but contain all the labels for %i %u %f replacements in their text
			bool webpageloaded;
			int zoom_factor;
			bool plasma; // set to true
			void setupUi( Plasma::PopupApplet& welcomePlasmoid );
			Plasma::PopupApplet *top;
			void createTopFrame();
			
	};
};
