=begin
# -*- coding utf-8 -*-
#/*
# * Copyright(c) 2008 Matthew Adams <roguestar191 at comcast.net>
# *
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License as
# * published by the Free Software Foundation; either version 2 of
# * the License, or(at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http//www.gnu.org/licenses/>.
# */
=end
require 'ftools'
class My_AboutHelper < Plasma::Dialog
	slots	:accept,
		:reject

	def intiialize(par=nil)
		super(par)
	end
	def init
                self.setMinimumSize(500,300)
                self.resize(500,300)
	end
	def paintInterface()
		return
	end
	def accept()
		self.hide()
	end
	def reject()
		self.hide()
	end

end
# The dialog class, popup a dialog, this could be used stand alone as the applet, just change initialize() to initialize(arg), and pass arg to super
class MyHelperDialog < Plasma::Dialog
# When the governor, freq, or cpu changes, call this function, connected via the "connect" call near the end of this class
    slots 'ToTDPreviousButtonClicked()',
	  'ToTDNextButtonClicked()',
	  'AboutButtonClicked()',
	  'PGetStartedClicked()',
	  'KGetStartedClicked()',
	  'KGeneralDocClicked()',
	  'PAPIWebsiteClicked()',
	  'PWebsiteClicked()',
	  'PlasmoidsInfoClicked()',
	  'KDEWebsiteClicked()',
	  'PActivitiesClicked()',
	  'accept()',
	  'reject()',
	  'changedSelection(QString)',
	  'urlLink(QUrl)',
	  'runUrlBackground()',
	  'progressBar(int)',
	  'systemsettings()',
          'packagemanager()',
	  'systemlogs()',
	  'konsole()',
	  'favoritePick(QListWidgetItem*)',
	  'addToFavorites()',
	  'remFavorite()',
	  'setUrlPlasma()',
	  'setUrl(QString)',
	  'urlLinkupdate(QUrl)'
# These two are "missing' from Plasma::Applet, there could be more, it's one of the downsides to using Qt::Designer, but I define them and let them
# Be set, but they don't do anything
    attr_accessor :sizeGripEnabled
    attr_accessor :modal
# public variables
    attr_accessor :dialog
    attr_accessor :layout
    attr_accessor :proxy
    attr_accessor :mytop
    attr_accessor :widget
    attr_accessor :objectName
    attr_accessor :plasmaDialog

# Initialize - the consutrctor
    def addUrlToHistory(m_url)
	@dialog.urlRequester.addToHistory(m_url.prettyUrl())
#	@dialog.urlRequester.setCurrentIndex(1)
	if(m_url.toString != 'about:blank')
                 if( isPlasma)
			if @dialog.tabWidget.currentIndex != 1
				@dialog.tabWidget.setCurrentIndex(1)
# This temporarily works around the tab widget activation bug in pre-4.2
				@dialog.tabWidget.nativeWidget.setCurrentIndex(0)
				@dialog.tabWidget.nativeWidget.setCurrentIndex(1)
			end
		end
	end
    end
    def repInHtml(text)
	if text == nil 
		return 
	end
	oneFound = false
	if text['%u'] != nil
		oneFound = true
		text = text.gsub("%u", `whoami`)
	end
	if text['%i'] != nil
		oneFound = true
		text = text.gsub("%i", @iconpath)
	end
	if text['%f'] != nil
		oneFound = true
		text.gsub("%f", @mytop.mydir[0,@mytop.mydir.length()-5] )
	end
	if( oneFound == false )
		return nil
	end
	return text

    end
    def rep(node)
	begin
	if(node == nil or node.objectName == nil) 
		return 
	end
	rescue
		if isPlasma == false
			return
		end
		if node == nil
			return
		end
	end
	begin
		if(isPlasma == false)
			node.text = node.text.gsub("%u", `whoami`)
			node.text = node.text.gsub("%i", @iconpath)
			node.text = node.text.gsub("%f", @mytop.mydir[0,@mytop.mydir.length()-5] )
		else
			node.setText( node.text().gsub("%u", `whoami`) )
			node.setText( node.text().gsub("%i", @iconpath) )
			node.setText( node.text().gsub("%f", @mytop.mydir[0,@mytop.mydir.length()-5] ) )
		end

	rescue

	end
	if isPlasma == false
		if(node.children != nil)
			node.children.each {
				|c|
				begin
					 rep c
				rescue
				end
			}
		end
	else

		begin		
	                if(node.mychildren != nil)
	                        node.mychildren.each {
					|c|
					begin
		                                rep c
					rescue

					end
	                        }
	                end
	
		rescue

		end
	end
    end
    def isPlasma()
       return @plasmaDialog
    end
    def initialize( rpar = nil , par=nil, top=nil)
	@objectName = ""
	
	super nil
	@top = par
        @modal = false
	@preProcessOnLoad = true
	@sizeGripEnabled= false

	@mytop = top
	@dialog = Ui::WelcomePlasmoid.new()
	@dialog.setupUi(self)
	@plasmaDialog = false
	begin
#If it doesn't even exist assume false
		@plasmaDialog = @dialog.plasma
	rescue

	end

	@iconpath = File.dirname(KDE::IconLoader.global().iconPath('terminal', -128))
	isize = @iconpath.index('128x128')
	@iconpath = @iconpath[0, isize]
	if isPlasma == false
		rep(self) #Must call after setting iconpath and setting up ui!!!
	else
		rep(@dialog)
	end

	puts @iconpath

	@urlFromWeb = false

   end
	def favoritePick(i)
		setUrl(i.text)
	end
	def remFavorite()
		@dialog.favoriteList.takeItem(@dialog.favoriteList.currentRow)
	end

	def addToFavorites()
#		lwi = Qt::ListWidgetItem(@dialog.favoriteList)
		@dialog.favoriteList.addItem( @dialog.motdlabel.url.toString )
	end

#Depricated
	def paintInterface(p, options, rect)
		return
	end

#End depricated

	def changedSelection(newFile)

		@mytop.setTipFile(newFile)
		@source = nil
                tip = @mytop.getTip()

		if(isPlasma)
			@dialog.motdlabel.setUrl(KDE::Url.new(""))
		else
			@dialog.motdlabel.url = Qt::Url.new("")
		end

		repped = repInHtml(@tip)
		if(repped != nil)
			@dialog.motdlabel.setHtml( repped )
		else
			@dialog.motdlabel.setHtml( tip )
		end
		return true
	end
        def urlLinkupdate(qUrl)
                puts "urlLinkupdate"
                @urlFromWeb = true
		@UpdateTextEntryBoxOnly=true
                if(isPlasma())
#			if(@dialog.motdlabel.mainFrame.url.toString != qUrl.toString)
#				@dialog.motdlabel.setUrl(KDE::Url.new(qUrl.toString))
#			end
#			@dialog.urlRequester.setEditUrl(KDE::Url.new(""))
			puts qUrl.toString
                        @dialog.urlRequester.setEditUrl(KDE::Url.new(qUrl.toString))
#			@dialog.urlRequester.addToHistory(qUrl.toString)
                else
                        @dialog.urlRequester.setPath(qUrl.toString)
                end

        end

	def urlLink(qUrl)
		puts "urlLink"
		@urlFromWeb = true
		if(isPlasma())
                        if(@dialog.motdlabel.mainFrame.url.toString != qUrl.toString)
				url = KDE::Url.new(qUrl.toString)
                                @dialog.urlRequester.setEditUrl(url)
				@dialog.motdlabel.setUrl(url)
                        end
		else
			@dialog.urlRequester.setPath(qUrl.toString)
		end

	end
	def setUrlPlasma()
		puts 'setUrlPlasma'
		setUrl( @dialog.urlRequester.currentText )
	end
	def setUrl(s)
		if @UpdateTextEntryBoxOnly
			@UpdateTextEntryBoxOnly = false
			return
		end
		if(s == nil)
			return
		end
		if isPlasma
			@dialog.urlRequester.reset()		
#			@dialog.urlRequester.setEditable(true)
		end
		puts 'seturl ' + s
		if @urlFromWeb == true and s[0,9] == 'command:/'
			# If you're wondering what this is about... it's security.
			# Using this the webview can't launch arbitrary commands
			# Without it they can by simply making a link that contains: <a href="command:/startx">link</a>
			# or even <a href="command://bin/su">su link</a> etc
			@urlFromWeb = false
			return
		end
		@urlFromWeb = false

		if s[0,5] == 'tip:/'
			if s['next'] != nil
				@dialog.motdlabel.setHtml( @mytop.nextTip() )
			end
			if s['prev'] != nil
				@dialog.motdlabel.setHtml( @mytop.prevTip() )
			end
			return	
		end
		if s[0,9] == 'command:/'
#			@dialog.urlRequester.addToHistory(cmd)
			cmd = s[9, s.length()-9]
			IO.popen(cmd)
			return
		end
		if s[0,1] == '/'
			s = 'file:'+s
		end
		if s.index(':') == nil
			s = 'http://'+s
		end
                if s[0,6] == 'help:/'
#                        @dialog.urlRequester.addToHistory(s)
			cmd = 'khelpcenter ' + s
                        IO.popen(cmd)
                        return
		end
		if(s[0,6] == 'file:/' and (s[s.length()-5,5] == '/tips'))# or s[s.length()-10,10] == '/tips.html'))
			puts 'File Set to: %s' % s
#			@dialog.urlRequestor.addToHistory(s)
			changedSelection(s)
			if( isPlasma)
			else
				@dialog.tabWidget.setCurrentIndex(1)	
			end
		else
			puts 'URL Set to: %s' % s
			if s[0,6] == 'file:/'
				@preProcessOnLoad = true
			else
#				@preProcessOnLoad = false
			end
			if(isPlasma == false)
				@dialog.tabWidget.setCurrentIndex(1)
			end
			changeUrl(s)
		end
		return true
	end
	def changeUrl(s)
		@source = s
	end
	def progressBar(s)
		if(s == 100) 
			if(@preProcessOnLoad == true)
#				@preProcessOnLoad = false
				repped = repInHtml(@dialog.motdlabel.page().currentFrame.toHtml())
				if(repped != nil)
					if isPlasma
						@dialog.motdlabel.setHtml(repped, KDE::Url.new(@dialog.motdlabel.mainFrame.url.toString))
						if @dialog.motdlabel.mainFrame.url.toString != 'about:blank'
							addUrlToHistory(KDE::Url.new(@dialog.motdlabel.mainFrame.url.toString))
						end
					else
						@dialog.motdlabel.setHtml(repped, @dialog.url)
					end
				else
					if isPlasma
						if @dialog.motdlabel.mainFrame.url.toString != nil
							if @dialog.motdlabel.mainFrame.url.toString != 'about:blank'
								addUrlToHistory(KDE::Url.new(@dialog.motdlabel.mainFrame.url.toString))
							end
						end
					else

					end
				end
			end
			if isPlasma
			else
				@dialog.webProgressBar.hide()
			end
		else 
			if isPlasma

			else
				if ( not @dialog.webProgressBar.isVisible()) 
					@dialog.webProgressBar.show() 
				end
			end
		end
	end
	def runUrlBackground()
		if @source == nil
			return
		end
		if @source[0,1] == '/'
			@source = 'file:'+@source
		end
		if @source['\:'] == nil
			@sorce = 'http://'+@source
		end

                if(@source == @lastsource)
                        return
                end

		if isPlasma == true
			if @dialog.motdlabel.mainFrame.url.toString != @source
				@dialog.motdlabel.setUrl(KDE::Url.new(@source))
#				@dialog.urlRequester.addToHistory(@source)
			end
		else
			if @dialog.motdlabel.url.toString != @source
				@dialog.motdlabel.url = Qt::Url.new(@source)
			end
		end


		@lastsource = @source
	end
	def accept()
	end
	def reject()
	end
	def findTipFiles()
		tipfiles = `locate /tips`.each
		tmptips = []

		for mtip in tipfiles:
			tip = String.new(mtip)
			tip = tip.chomp()
			length = tip.length()
			lengtho = length-5
			lengtht = length-10
			tfo = tip[lengtho,length-lengtho]
			tft = tip[lengtht,length-lengtht]
			if(tfo == "/tips" or tft == '/tips.html')
				if(File.directory?(tip) == false)
					tmptips << tip
				end
			end
		end
		for f in tmptips
			if(isPlasma == false)
				@dialog.tipFileBox.insertItems(0, [Qt::Application.translate("tOTDDialog", "file:"+f, nil, Qt::Application::UnicodeUTF8)])
			else
				@dialog.tipFileBox.addItem(Qt::Application.translate("tOTDDialog", 'file:'+f, nil, Qt::Application::UnicodeUTF8))
			end
		end
	end

   def settop(parent,applet)
	@mytop = parent
	@top = parent
	findTipFiles
	if @top != nil
		if(isPlasma == false)
			@dialog.motdlabel.url = Qt::Url.new(@mytop.nextTip())
		else
			@dialog.motdlabel.setUrl(KDE::Url.new(@mytop.nextTip()))
		end
	end
	if(isPlasma)
		rep(self)
	else
		rep(@mytop.applet())
	end
#	Qt::Object.connect(@dialog.remfavoritebut, SIGNAL('clicked()'), self, SLOT('remFavorite()'))
#	Qt::Object.connect(@dialog.addfavoritebut, SIGNAL('clicked()'), self, SLOT('addToFavorites()'))

	@dialog.motdlabel.page().setLinkDelegationPolicy(Qt::WebPage::DelegateAllLinks)

#	Qt::Object.connect(@dialog.systemsettingsbut, SIGNAL('clicked()'), self, SLOT('systemsettings()'))
#	Qt::Object.connect(@dialog.kpackagebut, SIGNAL('clicked()'), self, SLOT('packagemanager()'))
#	Qt::Object.connect(@dialog.systemlogbut , SIGNAL('clicked()'), self, SLOT('systemlogs()'))
#	Qt::Object.connect(@dialog.konsolebut , SIGNAL('clicked()'), self, SLOT('konsole()'))

	Qt::Object.connect(@dialog.favoriteList, SIGNAL('itemDoubleClicked(QListWidgetItem*)'), self, SLOT('favoritePick(QListWidgetItem*)'))

	if(@plasmaDialog)
		Qt::Object.connect(@dialog.motdlabel, SIGNAL('loadProgress(int)'), self, SLOT('progressBar(int)'))
	else
		Qt::Object.connect(@dialog.webProgressBar, SIGNAL('valueChanged(int)'), self, SLOT('progressBar(int)'))
	end
	
	if isPlasma
		Qt::Object.connect(@dialog.urlRequester, SIGNAL("textChanged(QString)"), self, SLOT('setUrl(QString)'))
	else
		Qt::Object.connect(@dialog.urlRequester, SIGNAL("returnPressed(QString)"), self, SLOT('setUrl(QString)'))	
	end
	Qt::Object.connect(@dialog.motdlabel.page(), SIGNAL('linkClicked(QUrl)'), self, SLOT('urlLink(QUrl)'))
	Qt::Object.connect(@dialog.motdlabel.mainFrame(), SIGNAL('urlChanged(QUrl)'), self, SLOT('urlLinkupdate(QUrl)'))

#	Qt::Object.connect(@dialog.motdprevbut, SIGNAL('clicked()'), self, SLOT('ToTDPreviousButtonClicked()'))
#	Qt::Object.connect(@dialog.motdnextbut, SIGNAL('clicked()'), self, SLOT('ToTDNextButtonClicked()'))

#	Qt::Object.connect(@dialog.pgetstartbut, SIGNAL('clicked()'), self, SLOT('PGetStartedClicked()'))
#        Qt::Object.connect(@dialog.papibut, SIGNAL('clicked()'), self, SLOT('PAPIWebsiteClicked()'))
#        Qt::Object.connect(@dialog.pwebsitebut, SIGNAL('clicked()'), self, SLOT('PWebsiteClicked()'))
#        Qt::Object.connect(@dialog.pactivitiesbut, SIGNAL('clicked()'), self, SLOT('PActivitiesClicked()'))
#        Qt::Object.connect(@dialog.plasmoidsbut, SIGNAL('clicked()'), self, SLOT('PlasmoidsInfoClicked()'))
#        Qt::Object.connect(@dialog.kdegetstartbut, SIGNAL('clicked()'), self, SLOT('KGetStartedClicked()'))
#        Qt::Object.connect(@dialog.kdedocbut, SIGNAL('clicked()'), self, SLOT('KGeneralDocClicked()'))
#        Qt::Object.connect(@dialog.kdewebsitebut, SIGNAL('clicked()'), self, SLOT('KDEWebsiteClicked()'))
#        Qt::Object.connect(@dialog.aboutbut, SIGNAL('clicked()'), self, SLOT('AboutButtonClicked()'))

#        Qt::Object.connect(@dialog.tipFileBox, SIGNAL('currentIndexChanged(QString)'), self, SLOT('changedSelection(QString)'))
        Qt::Object.connect(@dialog.tipFileBox.nativeWidget, SIGNAL('highlighted(QString)'), self, SLOT('setUrl(QString)'))	

	timer = Qt::Timer.new(parent)
	Qt::Object.connect(timer, SIGNAL('timeout()'), self, SLOT('runUrlBackground()'))
	timer.start(2000)
	Qt::MetaObject.connectSlotsByName(self)
    end
end



