/*
 *   Copyright (C) 2008 Petri Damsten <damu@iki.fi>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as
 *   published by the Free Software Foundation; either version 2, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef KROSSRUNNERSCRIPT_PYTHON_H
#define KROSSRUNNERSCRIPT_PYTHON_H

#include "krossrunnerscript.h"
#include <KComponentData>
#include <KPluginFactory>

class KrossRunnerScriptPython : public KrossRunnerScript
{
    Q_OBJECT
public:
    KrossRunnerScriptPython(QObject* parent, const QVariantList &args);
};

K_EXPORT_PLASMA_RUNNERSCRIPTENGINE(kross_python_runner,
                                   KrossRunnerScriptPython)

#endif // KROSSRUNNERSCRIPT_PYTHON_H

