#ifndef QUASAR_RENDERERNODE_H
#define QUASAR_RENDERERNODE_H

#include "graphicsnode.h"

class QGLFramebufferObject;

namespace Quasar
{
    class RendererNodePrivate;
    class RendererNode : public GraphicsNode
    {
        Q_OBJECT
        Q_DECLARE_PRIVATE(GraphicsNode)
    public:
        RendererNode(const QString &name);
        virtual bool isRendererNode() const;

        void setFramebufferObject(QGLFramebufferObject  *fbo);
        QGLFramebufferObject *framebufferObject() const;
  protected:
        RendererNode(const QString &name, NodePrivate &dd);

    protected:
        QGLFramebufferObject *m_fbo;
    };
}

#endif
