#ifndef QUASAR_SHADERNODE_P_H
#define QUASAR_SHADERNODE_P_H


#include "shadernode.h"
#include "node_p.h"

namespace Quasar
{
    class ShaderNode;
    class ShaderNodePrivate : public NodePrivate
    {
        Q_DECLARE_PUBLIC(Node)
    public:
        ShaderNodePrivate();
        bool checkLinkedProgram(GLuint prog);
        bool loadAndCompileShader(GLuint shader, const char *text);
    public:
        GLuint         fragShader;
        GLuint         vertShader;
        GLuint         prog;
        QString        currentVs;
        QString        currentFs;
    };
}

#endif
