/*
 *   Copyright © 2009 Dmitry Suzdalev (dimsuz@gmail.com)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef KLIPBOARD_DELEGATE_H
#define KLIPBOARD_DELEGATE_H

#include <Plasma/Delegate>

class KlipboardDelegate : public Plasma::Delegate
{
    Q_OBJECT

public:
    KlipboardDelegate(QObject* parent = 0);

    // reimp
    QSize sizeHint(const QStyleOptionViewItem& opt, const QModelIndex& index) const;

    // TODO: remove if no custom painting will be needed
    // reimp
//    void paint(QPainter* painter, const QStyleOptionViewItem& opt, const QModelIndex& index) const;
};

#endif
