#ifndef SEARCHPANE_H
#define SEARCHPANE_H

#include <QString>
#include <QWidget>

class QVBoxLayout;

class SearchPane : public QWidget
{
    Q_OBJECT
public:
	  SearchPane(QWidget *parent = 0);
	  ~SearchPane();

    QString getQueryString() const;
protected:
		
private slots:
    void addCriterion();
    void updateQuery();
    void removeCriterion();

signals:
    void signalAddCriterion();
    void queryChanged(QString query);

private:
    QString query;
    QVBoxLayout* layout;
};

#endif // SEARCHPANE_H
