#!/bin/sh

# create a new random kde home
CNT=0
KDEHOME=/tmp/kde_test_home_$CNT
while [ -e $KDEHOME ]
  do
  let "CNT += 1"
  KDEHOME=/tmp/kde_test_home_$CNT
done

export KDEHOME
export KDETMP=$KDEHOME/tmp
export KDEVARTMP=$KDEHOME/vartmp
export KDESYCOCA=$KDETMP/ksycoca-test
mkdir -p $KDEHOME
mkdir -p $KDETMP
mkdir -p $KDEVARTMP

# start kde basics
echo "Starting new KDE session in $KDEHOME..."
kbuildsycoca4 2> /dev/null
kdeinit4 2> /dev/null
qdbus org.kde.kded /kded org.kde.kded.loadSecondPhase 2> /dev/null

# start the actual test
echo "Starting test case..."
eval $@

# shutdown KDE
echo "Shutting down KDE session..."
kdeinit4_shutdown

echo "Cleaning up temporary KDEHOME $KDEHOME"
#rm -rf $KDEHOME
