=begin
#!/usr/bin/env kross
# -*- coding utf-8 -*-
#/*
# * Copyright(c) 2008 Matthew Adams <roguestar191 at comcast.net>
# *
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License as
# * published by the Free Software Foundation; either version 2 of
# * the License, or(at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http//www.gnu.org/licenses/>.
# */
# Fixed by rdale, THANK YOU !
#
# Some parts shamelessly stolen (borrowed) and brutally chopped up from the plasmoid examples in kde
# 
# The base is PlasmaScripting::Applet. On top of that is my applet - which draws it's text to the applet
# What a pain in the ass
# Anyway, work like the clock to resize properly
# Grab mouse clicks, open dialog
# Create the dialog, populate it 
# On click move dialog and show it - only move the first time
# Dialogs should be resizeable - but plasma seems to have disabled this in 4.2beta2
#
#
=end

require 'korundum4'
require 'Qt4'

require 'thread'
# The actual UI. All the ui MUST contain is freqlistview and govlistview, cpulistview, and gpllabel, don't let their names decieve you
# They're not listview's, they're listwidgets. 
require 'Ui_PopupDialog'
require 'gpl.rb'
require 'DialogHelper'

require 'plasma_applet'
class CpuHelper
            def initialize()
		# init to junk value, will never be true first time
		@lastcpu = -2
            end
            def notSameAsLastCpu(curcpu)
                ret = true
		if(curcpu == @lastcpu)
			ret = false
		end
                @lastcpu = curcpu
                return ret
            end
end

# Now the heart of the program
module RubyCpufreq
        class Main < PlasmaScripting::Applet
# Let the other programs read the governor, frequency, and my native Qt Widget just in case
            attr_reader :governor
            attr_reader :frequency
	    attr_reader :mywidget
	    attr_accessor :Text
	    attr_accessor :activeCpu
		slots 'dataUpdated(QString,Plasma::DataEngine::Data)',
		      'createConfigurationInterface(KConfigDialog *)',
		       :updateColors,
		       :updateme,
		       :clickedon
# Let applet be a child
            def initialize(parent,args=nil)
                super
		@parent = parent
		@top = @parent
		@activeCpu = 0
            end
	def updateme
		getCurrentMode()
		@Text = frequency
		update()
		return true
	end
	def applet()
		return @top.applet()
	end
	# Init function, create everything
            def init
		self.show()
		@fm = Qt::FontMetrics.new(Qt::Application.font)
		@fpcurfreq = nil
		@fpcurgov = nil
		@fpfreqlist = nil
		@fpgovlist = nil
		@lastcpu = -1
		#resize
		metrics = Qt::FontMetricsF.new(KDE::GlobalSettings.smallestReadableFont)
		text = '  800MHZ  '
		@minsize = metrics.size(Qt::TextSingleLine, text)
		@minsize = @minsize * 2

		setMinimumSize(@minsize)
#		@top.applet().setAspectRatioMode(Plasma::Square)
		@top.applet().setMinimumSize(@minsize)
#		setAspectRatioMode(Plasma::Square)
# Create an svg for the theme
		@svg = Plasma::Svg.new(@top.applet())
# Set to default theme
		@svg.imagePath = 'widgets/background'
		

                @frequency = nil
                @governor = nil
		@clickedyet = false

                timer = Qt::Timer.new(parent)

                @top.applet().connect(timer, SIGNAL('timeout()'), self, SLOT(:updateme))
                timer.start(500);

                @c = PopupDialog.new 
# Set the top to this Plasma::Applet, and pass in the freqBox's native widget
                @c.settop(self)
# hide the dialog
		@c.move(popupPosition(@c.size()))
# setup my ui - this is where the dialog should really be created instead of up here....
                setupUi()
		resize(@minsize)
            end

	def mousePressEvent(e)
		if e.buttons == Qt::LeftButton
			clickedon(e)
			return true
		else
			e.ignore
		end
	end
# "Borrowed" from clock applet
	  def constraintsEvent(constraints) 
	    if constraints & Plasma::SizeConstraint.to_i
	      aspect = 2
	      if formFactor == Plasma::Horizontal
	        # We have a fixed height, set some sensible width
	        self.setMinimumWidth(geometry.height * aspect)
	      elsif formFactor == Plasma::Vertical
	        # We have a fixed width, set some sensible height
	        self.setMinimumHeight(geometry.width / aspect)
	      end

	    end
	  end

	def clickedon(e=nil)
	        def click(parent, qobj) # Parent is the applet, @qobj is the dialog
			if(qobj == nil or parent == nil)
				puts "Warn, parent or qobj is nil"
				return
			end
			if(qobj.isVisible()) 
				qobj.hide()
				return
			end
			if @clickedyet == false
				qobj.move(@top.applet().popupPosition(qobj.size))
					@clickedyet = true
					# Only run this the first time the window is opened, after that, use the values stored on the window
					# This allows custom positions and resizing - when plasma allows it ...
			end
				# Show the window (not maximized and restore from the task tray if it's minimized)
			qobj.showNormal()
			# Raise it above other windows
			qobj.raise()
			# Give it activation
			qobj.activateWindow()
		end
		# Do the click.
		click(@svg,@c)
	    end
            def shape()
                """Fix this"""
                path = Qt::Painter.Path.new
                path.addRect(boundingRect().adjusted(geometry()))
                return path
            end 

            def paintInterface( p, option, rect)
   		
		margin = 4
		textRect = nil

		textRect = rect

		p.pen = Qt::NoPen
#		background = Plasma::Theme.defaultTheme.color(Plasma::Theme::BackgroundColor)
#		background.setAlphaF(0.0)
#		p.brush = Qt::Brush.new(background)

		p.renderHint = Qt::Painter::SmoothPixmapTransform
		p.renderHint = Qt::Painter::Antialiasing

		p.drawPath(Plasma::PaintUtils.roundedRectangle(Qt::RectF.new(textRect.adjusted(-margin, -margin, margin, margin)), margin))

		p.pen = Plasma::Theme::defaultTheme.color(Plasma::Theme::TextColor)
		@plainFont = KDE::GlobalSettings.generalFont
		@plainFont.pointSizeF = [rect.height, KDE::GlobalSettings.smallestReadableFont.pointSize].max

		preparePainter(p, rect, @plainFont, @Text)        
		p.drawText(Qt::RectF.new(rect), @Text, Qt::TextOption.new(Qt::AlignCenter))
#		@svg.resize(rect.left+rect.right+1, rect.top+rect.bottom+1);
#                @svg.paint(p, Qt::RectF.new(rect), "widgets/background")# contentsRect.left(),contentsRect.top())

#		resize(rect.left+rect.right+1, rect.top+rect.bottom+1)
		p.save()
		p.restore()
            end
	 def preparePainter(p, rect, font, text)
	    tmpRect = Qt::Rect.new
	    tmpFont = font
	
	    # Starting with the given font, decrease its size until it'll fit in the
	    # given rect allowing wrapping where possible
	    begin
	        p.font = tmpFont
	        tmpFont.pointSize = [KDE::GlobalSettings.smallestReadableFont.pointSize, tmpFont.pointSize - 1].max
	        tmpRect = p.boundingRect(rect, Qt::TextWordWrap, text)
	    end while tmpFont.pointSize > KDE::GlobalSettings.smallestReadableFont.pointSize && (tmpRect.width > rect.width ||
	            tmpRect.height > rect.height)
	
	    return tmpRect
	  end
	
            def open(fname, arg)
                return File.new(fname, arg)
            end

#
# The next five functions are the heart of the program, where it talks with cpufreq and it's modules
#
# Available vs Current
# Available makes a call to the dialog to add all the governors or frequencies to the appropriate listwidget
# Current sets frequency and governor on the local system
#First function gets list of cpu's
# Change to cpufreq-info method!
	   def getAvailableCpus()
#		str = `cpufreq-info | grep CPU[' '][0-9]:*`
		str = `ls -d /sys/devices/system/cpu/cpu[0-9]*`
		str = str.split(' ')
		@c.fillcpuListView(str)
#		puts str
		return
	   end


# Use CPU0 by default - should find a way to configure it to allow other cpu's to be controlled and multiple cpu's at once.
# My dual core however runs both cores from the settings of just one of them so I have no need, someone else, go for it!
            def getAvailableModes( )
                if(!@cavailfreq)
                        @cavailfreq = CpuHelper.new()
                end
		if(@cavailfreq.notSameAsLastCpu(@activeCpu))
			str = '/sys/devices/system/cpu/cpu%s/cpufreq/scaling_available_frequencies'
	        	str = str.sub('%s', @activeCpu.to_s)
                        if (@fpfreqlist != nil)
                                @fpfreqlist.close()
                        end

		        @fpfreqlist = open(str,'r')
		end
		@fpfreqlist.seek(0)
		modearray = Array.new
                for line in @fpfreqlist.read().split(' ')
                        line = line.chomp()
# Copy the original line for the map
			lineorig = line
                	if(line.length > 6)
                        	line = line.slice(0,line.length-4)
	                        line.insert(1, ".")
	                        line = line + "GHz"
	                else
	                        if(line.length > 4)
	                                line = line.slice(0, line.length-3)
	                                line = line + "MHz"
	                        end
	                end
			modearray << [line, lineorig]
                end
		@c.fillfreqListViews(modearray)
            end

            def getAvailableGovernors( )
                if(!@cavailgov)
                        @cavailgov = CpuHelper.new()
                end
		if(@cavailgov.notSameAsLastCpu(@activeCpu))
			str = '/sys/devices/system/cpu/cpu%s/cpufreq/scaling_available_governors'
			str = str.sub('%s', @activeCpu.to_s)
			if (@fpgovlist != nil)
                                @fpgovlist.close()
                        end

	                @fpgovlist = open(str, 'r')
		end
		@fpgovlist.seek(0)
		govarray = Array.new
                for line in @fpgovlist.read().split(' ')
                        line = line.chomp()
			if(line != 'userspace')
				govarray << line
			end
                end
		@c.fillgovListViews(govarray)
            end 

            def getCurrentMode()
                if(!@cfreqlfreq)
                        @cfreqlfreq = CpuHelper.new()
                end
		 if(@cfreqlfreq.notSameAsLastCpu(@activeCpu)) 
			str = '/sys/devices/system/cpu/cpu%s/cpufreq/scaling_cur_freq'
			str = str.sub('%s', @activeCpu.to_s)
			if (@fpcurfreq != nil)
				@fpcurfreq.close()
			end
			@fpcurfreq = open(str, 'r')
		end
		@fpcurfreq.seek(0)
                line = @fpcurfreq.read()
                line = line.chomp()
		if(line.length > 6)
			line = line.slice(0,line.length-4)
			line.insert(1, ".")
			line = line + "GHz"	
		else
			if(line.length > 4)
				line = line.slice(0, line.length-3)
				line = line + "MHz"
			end
		end
                @frequency = line

            end

            def getCurrentGovernor()
		if(!@cgovlfreq)
			@cgovlfreq = CpuHelper.new()
		end
		if(@cgovlfreq.notSameAsLastCpu(@activeCpu)) 
			str = '/sys/devices/system/cpu/cpu%s/cpufreq/scaling_governor'
			str = str.sub('%s', @activeCpu.to_s)
			if (@fpcurgov != nil) 
				@fpcurgov.close()
			end
	                @fpcurgov = open(str, 'r')
		end
		@fpcurgov.seek(0)
                line = @fpcurgov.read()
        #.split('\n')
                line = line.chomp()
                @governor = line
            end
#            def sameAsLaistCpu(curcpu)
#		ret = true
#		if(@lastgov != nil)
#			if(curcpu == @lastcpu)
#				ret = false
#			end
#		end
#		@lastcpu = curcpu
#		return ret
#            end
            def setupDialogDisplay()
		begin
                	getCurrentGovernor()
	                getCurrentMode()
		rescue
                       Qt::MessageBox.critical(nil, "No CpuFreq", "Error, You do not have the CPU Frequency modules running, please find documentation on setting up the cpufreq modules with the kernel appropriate for your cpu!", KDE::MessageBox::Ok)
			Process.exit
		
		end
# This is where the dialog finally gets it's values		
                getAvailableModes()
                getAvailableGovernors()
		getAvailableCpus()
            end

            def setupUi()
	#This function must be renamed, and comments removed, all it does now is get frequencies and setup all that initially
                setupDialogDisplay()
            end
        end
end

