#ifndef QUASAR_BRIGHTNESSNODE_P_H
#define QUASAR_BRIGHTNESSNODE_P_H

#include "filternode.h"
#include <GL/gl.h>

namespace Quasar
{
    class BrightnessNode : public FilterNode
    {
        Q_OBJECT
    public:
        BrightnessNode();

        virtual QRectF domainOfDefinition(const QRectF &rect) const;
        virtual QRectF regionOfInterest(const QRectF &rect) const;

        virtual void aboutToExecute();
    protected:
        void programChanged(GLuint prog);
    private:
        GLuint m_alphaLoc;
    };
}

#endif
